unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ActnList, StdActns, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    PaintBox1: TPaintBox;
    Button1: TButton;
    Timer1: TTimer;
    Button2: TButton;
    ActionList1: TActionList;
    FontEdit1: TFontEdit;
    ColorSelect1: TColorSelect;
    Button3: TButton;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Edit2: TEdit;
    UpDown2: TUpDown;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure UpDown2Changing(Sender: TObject; var AllowChange: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  y,dy,i:integer;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
AllowChange: Boolean;
begin
PaintBox1.Font:=FontEdit1.Dialog.Font;
PaintBox1.Canvas.Brush.Style:=bsSolid;
PaintBox1.Canvas.Brush.Color:=ColorSelect1.Dialog.Color;
PaintBox1.Color:=ColorSelect1.Dialog.Color;
y:=PaintBox1.Height;
UpDown1Changing(Sender,AllowChange);
UpDown2Changing(Sender,AllowChange);
Timer1.Enabled:=true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
PaintBox1.Canvas.Rectangle(0,0,PaintBox1.Width,PaintBox1.Height);
for i:=0 to Memo1.Lines.Count-1 do
 PaintBox1.Canvas.TextOut(1,y+PaintBox1.Font.Size*i*2,Memo1.Lines[i]);

y:=y-dy;
if y+PaintBox1.Font.Size*i*2<=0 then y:=PaintBox1.Height;
end;

procedure TForm1.UpDown1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
dy:=StrToInt(Edit1.Text);
end;


procedure TForm1.UpDown2Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
Timer1.Interval:=StrToInt(Edit2.Text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Form1.HelpContext:=2;
end;

end.
